from syntax import *
from cfg import Cfg
from iteration import fixpoint_iteration
from constant_propagation import Constant_propagation

x = AEVar("x")
y = AEVar("y")
c = AEVar("c")
one = AECst(1)
zero = AECst(0)

propagate_compute=ISeq(ISet("x",one),ISet("x", AEBop(Bop.ADD,x,one)))
same_branch_if=ICond(BELeq(c,zero), ISet("y", one), ISet("y",one))
equal_branch=ICond(BEEq(c,one),ISkip(),ISet("c",one))

prog = ISeq(ISeq(propagate_compute,same_branch_if),equal_branch)

print(prog)
cfg = Cfg(prog)

cst_propagation = Constant_propagation(prog)

res = fixpoint_iteration(cst_propagation,cfg)

for (node, state) in res.items():
    print(f"{node}:")
    if state is None: print("  None")
    else:
        for (var, value) in state.items():
            print(f"  {var} -> {value}")
